//+------------------------------------------------------------------+
//|                                                   _i_FXGauge.mq4 |
//|                                     Copyright  2006, Doji Starr |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Doji Starr"

#property indicator_chart_window
#property indicator_color1 Magenta
#property indicator_color2 Brown
#property indicator_color3 Lime
#property indicator_color4 DarkSlateGray
#property indicator_color5 Yellow
#property indicator_color6 LightSlateGray
#property indicator_color7 White
#define NBSL   8       // number of blue shade levels
#define NSVR    17      // number of solid vertical lines


// input params
extern string info_____ = "---- Time Frames (in minutes) ----";
extern int TF1 = 1;
extern int TF2 = 5;
extern int TF3 = 15;
extern int TF4 = 60;
static int prevtime,prev_short_setup,prev_long_setup,toggle_status;
static double prev_win_price_min;
string info____ = "---- Chart Shift, Spacing and Width ----";
extern int Shift = 3;
extern int Spacing = 5;
extern int Width = 4;
extern string info_  = "---- Target Settings - SET to Zero to disable ---";
extern string info__ = "---- target_pips2 is thickest ---";
extern int target_pips1=10;
extern int target_pips2=15;
extern int target_pips3=20;
extern string info_______ = "---- Since the 7th MA is supposed to be the strongest - make it thicker to stand out ----";
extern bool thick_7th_MA = true;
static int started;
// vars
int counted_bars, startBar, bar, i;
int gap=15;
int tf, c, offset, xUnit;
int shift, spacing, width;
int tfa[4];
double point;
double fml[4][7];                               // momentum lines
double bsl_up[4][NBSL];                         // blue shades levels to the up side
double bsl_down[4][NBSL];                       // blue shades levels to the down side
double _bsl[NBSL] = {9, 16, 26, 42, 68, 110, 178, 244};
int srgap;                                           // blue shades distances
double bsl[NBSL];                               // blue shades distances ('point' adjusted)
double tmpArray[7], lowestMA, highestMA;
double srl[24];                                 // support/resistance levels (total = 2*NBSL + 7 + 1(Bid) )
double price;
string objName;
datetime curTime;
int ma_period[9];
//color blueShade[NBSL] = {LightBlue, LightSkyBlue, CornflowerBlue, RoyalBlue, Blue};
color blueShade[NBSL] = {C'216,239,255', C'167,224,254', C'96,215,255', C'1,191,223', C'16,137,218', C'0,0,255', C'0,0,255'};
color col;
int ma[10];
int tft[10];
color traffic_light_color[10];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
deinit();
if(started!=-999)
{
//ObjectDelete("Toggle");
started=-999;
}

//ObjectCreate("Toggle",OBJ_TEXT,0,Time[WindowFirstVisibleBar()-50],WindowPriceMin()+0.010);
    tfa[0] = TF1;
    tfa[1] = TF2;
    tfa[2] = TF3;
    tfa[3] = TF4;

    xUnit = Period() * 60;
    shift = Shift * xUnit;
    spacing = Spacing * xUnit;
    width = Width * xUnit;
    
    for (i=0; i<NBSL; i++)
        bsl[i] = _bsl[i]*point;

    // creating the objects for drawing the grid    
    for (tf=0; tf<4; tf++)
    {
        // blue shade rectangles and bars
        for (i=0; i<NBSL; i++)
        {
            objName = "bsl_up_rect_"+tf+"_"+i;
            ObjectCreate(objName, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
            ObjectSet(objName, OBJPROP_COLOR, blueShade[i]);
            
            objName = "ext_bsl_up_rect_"+tf;
            ObjectCreate(objName, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
            ObjectSet(objName, OBJPROP_COLOR, Blue);
            
            objName = "bsl_down_rect_"+tf+"_"+i;
            ObjectCreate(objName, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
            ObjectSet(objName, OBJPROP_COLOR, blueShade[i]);
            
            objName = "ext_bsl_down_rect_"+tf;
            ObjectCreate(objName, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
            ObjectSet(objName, OBJPROP_COLOR, Blue);
            
            objName = "bsl_up_bar_"+tf+"_"+i;
            ObjectCreate(objName, OBJ_TREND, 0, 0, 0, 0, 0);
            ObjectSet(objName, OBJPROP_COLOR, Black);
            ObjectSet(objName, OBJPROP_RAY, false);
            ObjectSet(objName, OBJPROP_WIDTH, 1);
            
            objName = "bsl_down_bar_"+tf+"_"+i;
            ObjectCreate(objName, OBJ_TREND, 0, 0, 0, 0, 0);
            ObjectSet(objName, OBJPROP_COLOR, Black);
            ObjectSet(objName, OBJPROP_RAY, false);
            ObjectSet(objName, OBJPROP_WIDTH, 1);
            
      
        }
        objName = "MidShade_"+tf;
        ObjectCreate(objName, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
        ObjectSet(objName, OBJPROP_COLOR, White);
        
        // S&R boxes
        objName = "Box1_"+tf;
        ObjectCreate(objName, OBJ_ARROW, 0, 0, 0);
        ObjectSet(objName, OBJPROP_ARROWCODE, 1);
        objName = "Box2_"+tf;
        ObjectCreate(objName, OBJ_ARROW, 0, 0, 0);
        ObjectSet(objName, OBJPROP_ARROWCODE, 1);
        
        // momentum lines bars
        for (i=0; i<7; i++)
        {
            objName = "fml_bar_"+tf+"_"+i;
            ObjectCreate(objName, OBJ_TREND, 0, 0, 0, 0, 0);
            ObjectSet(objName, OBJPROP_COLOR, Black);
            ObjectSet(objName, OBJPROP_RAY, false);
            if (i<2)
                ObjectSet(objName, OBJPROP_WIDTH, 5);
            else if (i==6 && thick_7th_MA )
                ObjectSet(objName, OBJPROP_WIDTH, 5);
            else
                ObjectSet(objName, OBJPROP_WIDTH, 1);
        }
        
        // solid vertical lines (of 10 pips or more)
        for (i=1; i<=NSVR; i++)
        {
            objName = "svr_"+tf+"_"+i;
            ObjectCreate(objName, OBJ_TREND, 0, 0, 0, 0, 0);
            ObjectSet(objName, OBJPROP_RAY, false);
            ObjectSet(objName, OBJPROP_WIDTH, 3);
            
            objName = "ext_up_svr_"+tf;
            ObjectCreate(objName, OBJ_TREND, 0, 0, 0, 0, 0);
            ObjectSet(objName, OBJPROP_RAY, false);
            ObjectSet(objName, OBJPROP_WIDTH, 3);
            
            objName = "ext_down_svr_"+tf;
            ObjectCreate(objName, OBJ_TREND, 0, 0, 0, 0, 0);
            ObjectSet(objName, OBJPROP_RAY, false);
            ObjectSet(objName, OBJPROP_WIDTH, 3);
            
        }

    }
        
    return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
    // deleting the drawing objects
  //  ObjectDelete("Toggle");
    for (tf=0; tf<4; tf++)
    {
        for (i=0; i<NBSL; i++)
        {
            ObjectDelete("bsl_up_rect_"+tf+"_"+i);
            ObjectDelete("bsl_down_rect_"+tf+"_"+i);
            ObjectDelete("bsl_up_bar_"+tf+"_"+i);
            ObjectDelete("bsl_down_bar_"+tf+"_"+i);

        }
            ObjectDelete("ext_bsl_down_rect_"+tf);
            ObjectDelete("ext_bsl_up_rect_"+tf);
            ObjectDelete("ext_up_svr_"+tf);
            ObjectDelete("ext_down_svr_"+tf);
        ObjectDelete("MidShade_"+tf);
        
        ObjectDelete("Box1_"+tf);
        ObjectDelete("Box2_"+tf);
        
        for (i=0; i<7; i++)
            ObjectDelete("fml_bar_"+tf+"_"+i);
            
        for (i=1; i<=NSVR; i++)
            ObjectDelete("svr_"+tf+"_"+i);
    }

    return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
Comment("v1.1");
ma_period[0] = 21;
ma_period[1] = 34;
ma_period[2] = 55;
ma_period[3] = 75;
ma_period[4] = 100;
ma_period[5] = 144;
ma_period[6] = 233;
 double average1,average2;
   string dir="O";
   int tfc,mac;
   ma[0]=21;
   ma[1]=34;
   ma[2]=55;
      ma[3]=75;
   ma[4]=100;
   ma[5]=144;
      ma[6]=233;
  
   tft[0]=1;
   tft[1]=5;
   tft[2]=15;
   tft[3]=60;
   traffic_light_color[0]=indicator_color3;
   traffic_light_color[1]=indicator_color2;
   traffic_light_color[2]=indicator_color1;
   traffic_light_color[3]=indicator_color4;
   traffic_light_color[4]=indicator_color5;
   traffic_light_color[5]=indicator_color6;
   traffic_light_color[6]=indicator_color7;

   for(tfc=0; tfc<1; tfc++)
   {
   for(mac=0; mac<7; mac++)
   {
   average1=iMA(Symbol(),tft[tfc],ma[mac],0,MODE_SMA,PRICE_CLOSE,0);
   average2=iMA(Symbol(),tft[tfc],ma[mac],0,MODE_SMA,PRICE_CLOSE,1);
  
   if (average1>average2) dir="^";
   if (average1<average2) dir="v";
   
   string obj_name;
   obj_name="Light "+DoubleToStr(tfc,0)+DoubleToStr(mac,0);
   show_light(obj_name,average1, traffic_light_color[mac],mac,dir);
   
   }
   }
Comment("");
point=Point;
if(point<0.0001) point=0.0001;
/*

    if (Bars-IndicatorCounted() > 2)
        return;
*/
double win_height=WindowPriceMax()-WindowPriceMin();
int posx;
posx=WindowFirstVisibleBar()*0.7;


//posx=WindowFirstVisibleBar()-10;
//Alert(posx);
if(toggle_status==0) toggle_status=1;
 obj_name="Toggle";
//Alert(ObjectFind(obj_name));
if(ObjectFind(obj_name)<0)
{

//ObjectCreate(obj_name,OBJ_TEXT,NULL,Time[posx],WindowPriceMin()+(win_height*20/100));
if(toggle_status==-1)
{
ObjectSetText(obj_name,"Alert - On ");//("+DoubleToStr(gap,0)+")");
toggle_status=1;
}
else
{
ObjectSetText(obj_name,"Alert - Off ");//("+DoubleToStr(gap,0)+")");
toggle_status=-1;
}
}


ObjectSet(obj_name,OBJPROP_TIME1,Time[posx]);
ObjectSet(obj_name,OBJPROP_PRICE1,WindowPriceMin()+(win_height*20/100));

 obj_name="Test Alert";
if(ObjectFind(obj_name)<0) //Alert("Alert Test");
//ObjectCreate(obj_name,OBJ_TEXT,NULL,Time[posx],WindowPriceMin()+(win_height*10/100));
ObjectSetText(obj_name,"Test Alert");
ObjectSet(obj_name,OBJPROP_TIME1,Time[posx]);
ObjectSet(obj_name,OBJPROP_PRICE1,WindowPriceMin()+(win_height*10/100));
//Comment("");
int short_gap_count;
int long_gap_count;
int sr_short_gap_count;
int sr_long_gap_count;
//if (Minute()!=prevtime)
 init();

ObjectDelete("Highg");
ObjectDelete("Lowg");
if ( target_pips2 > 0 ) {
         ObjectCreate("Highg",OBJ_TREND,0,Time[100], Ask+(target_pips2*point),Time[1],Ask+(target_pips2*point));
      ObjectSet("Highg",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSet("Highg",OBJPROP_WIDTH,3);
      ObjectSet("Highg",OBJPROP_RAY,false);
      ObjectSet("Highg",OBJPROP_COLOR,Gray);
   
         ObjectCreate("Lowg",OBJ_TREND,0,Time[100], Bid-(target_pips2*point),Time[1],Bid-(target_pips2*point));
      ObjectSet("Lowg",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSet("Lowg",OBJPROP_WIDTH,3);
      ObjectSet("Lowg",OBJPROP_RAY,false);
      ObjectSet("Lowg",OBJPROP_COLOR,Gray);
}
ObjectDelete("Highgl");
ObjectDelete("Lowgl");
if ( target_pips1 > 0 ) {
         ObjectCreate("Highgl",OBJ_TREND,0,Time[100], Ask+(target_pips1*point),Time[1],Ask+(target_pips1*point));
      ObjectSet("Highgl",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSet("Highgl",OBJPROP_WIDTH,1);
      ObjectSet("Highgl",OBJPROP_RAY,false);
      ObjectSet("Highgl",OBJPROP_COLOR,Gray);
   
         ObjectCreate("Lowgl",OBJ_TREND,0,Time[100], Bid-(target_pips1*point),Time[1],Bid-(target_pips1*point));
      ObjectSet("Lowgl",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSet("Lowgl",OBJPROP_WIDTH,1);
      ObjectSet("Lowgl",OBJPROP_RAY,false);
      ObjectSet("Lowgl",OBJPROP_COLOR,Gray);
}
ObjectDelete("Highgh");
ObjectDelete("Lowgh");
if ( target_pips3 > 0 ) {
         ObjectCreate("Highgh",OBJ_TREND,0,Time[100], Ask+(target_pips3*point),Time[1],Ask+(target_pips3*point));
      ObjectSet("Highgh",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSet("Highgh",OBJPROP_WIDTH,1);
      ObjectSet("Highgh",OBJPROP_RAY,false);
      ObjectSet("Highgh",OBJPROP_COLOR,Gray);
   
         ObjectCreate("Lowgh",OBJ_TREND,0,Time[100], Bid-(target_pips3*point),Time[1],Bid-(target_pips3*point));
      ObjectSet("Lowgh",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSet("Lowgh",OBJPROP_WIDTH,1);
      ObjectSet("Lowgh",OBJPROP_RAY,false);
      ObjectSet("Lowgh",OBJPROP_COLOR,Gray);
}
  //Comment( "                                                             "+the_time());
//    curTime = TimeCurrent();
    curTime = Time[0];
//    price = Bid;
    price = Close[0];
    
    for (tf=0; tf<4; tf++)
    {
//        bar = 0;
        bar = iBarShift(NULL, tfa[tf], curTime, false);

        // populating the fml array...
        for (i=0; i<7; i++)
            {//fml[tf][i] = iCustom(NULL, tfa[tf], "_i_FXGaugeMAs", i, bar);
            fml[tf][i] = iMA(NULL, tfa[tf], ma_period[i], 0, MODE_SMA, PRICE_CLOSE, bar/Period());}
           //  fml[tf][i] = iMA(NULL, tfa[tf], "_i_FXGaugeMAs", i, bar);
        // finding the highest and lowest MAs from the 7 fml's
        for (i=0; i<7; i++)
            tmpArray[i] = fml[tf][i];     // copying the MAs levels of this TF to one dim array to feed ArrayBsearch
        ArraySort(tmpArray);
        lowestMA = tmpArray[0];
        highestMA = tmpArray[6];

        // populating the bsl arrays...
        for (i=0; i<NBSL; i++)
        {
            bsl_up[tf][i] = lowestMA + bsl[i];
            bsl_down[tf][i] = highestMA - bsl[i];
        }
    }
    
    // OK... now drawing
    for (tf=0; tf<4; tf++)
    {
        // drawing the blue shades of the grid from top to bottom
        
        // find the number of overlapping shades
        offset = 0;
        for (i=offset; i<NBSL-1; i++)
            if (bsl_up[tf][i] <= bsl_down[tf][i])
                offset++;
//Print(offset);
        // hide the objects of the first level of overlapping so they wont be left as 'ghosts'
        if (offset > 0)
        {
            objName = "bsl_up_rect_"+tf+"_"+(NBSL-2-offset+1);
            ObjectSet(objName, OBJPROP_TIME1, 0);
            ObjectSet(objName, OBJPROP_TIME2, 0);
            ObjectSet(objName, OBJPROP_PRICE1, 0);
            ObjectSet(objName, OBJPROP_PRICE2, 0);

            objName = "bsl_up_bar_"+tf+"_"+(NBSL-2-offset+1);
            ObjectSet(objName, OBJPROP_TIME1, 0);
            ObjectSet(objName, OBJPROP_TIME2, 0);
            ObjectSet(objName, OBJPROP_PRICE1, 0);
            ObjectSet(objName, OBJPROP_PRICE2, 0);
        }
        
        double highest=0;
        for (i=NBSL-2; i>=offset; i--)
        {
            objName = "bsl_up_rect_"+tf+"_"+(i-offset);
            ObjectSet(objName, OBJPROP_TIME1, curTime+shift+tf*spacing);
            ObjectSet(objName, OBJPROP_TIME2, curTime+shift+tf*spacing+width);
            ObjectSet(objName, OBJPROP_PRICE1, bsl_up[tf][i]);
            ObjectSet(objName, OBJPROP_PRICE2, bsl_up[tf][i+1]);
                
            if (bsl_down[tf][i]>highest) highest=bsl_up[tf][i+1];
            
            objName = "bsl_up_bar_"+tf+"_"+(i-offset);
            ObjectSet(objName, OBJPROP_TIME1, curTime+shift+tf*spacing+xUnit);
            ObjectSet(objName, OBJPROP_TIME2, curTime+shift+tf*spacing+width-xUnit);
            ObjectSet(objName, OBJPROP_PRICE1, bsl_up[tf][i]);
            ObjectSet(objName, OBJPROP_PRICE2, bsl_up[tf][i]);
        }
          
          
       objName = "ext_bsl_up_rect_"+tf;
       ObjectSet(objName, OBJPROP_TIME1, curTime+shift+tf*spacing);
       ObjectSet(objName, OBJPROP_TIME2, curTime+shift+tf*spacing+width);
       ObjectSet(objName, OBJPROP_PRICE1, highest);
       ObjectSet(objName, OBJPROP_PRICE2, WindowPriceMax());
            
                            objName = "ext_up_svr_"+tf;
                ObjectSet(objName, OBJPROP_TIME1, curTime+shift+tf*spacing+2*xUnit);
                ObjectSet(objName, OBJPROP_TIME2, curTime+shift+tf*spacing+2*xUnit);
                ObjectSet(objName, OBJPROP_PRICE1, highest);
                ObjectSet(objName, OBJPROP_PRICE2, WindowPriceMax());   
                            ObjectSet(objName, OBJPROP_COLOR, Green); 
        objName = "MidShade_"+tf;
        ObjectSet(objName, OBJPROP_TIME1, curTime+shift+tf*spacing);
        ObjectSet(objName, OBJPROP_TIME2, curTime+shift+tf*spacing+width);
        ObjectSet(objName, OBJPROP_PRICE1, bsl_up[tf][offset]);
        ObjectSet(objName, OBJPROP_PRICE2, bsl_down[tf][offset]);

        // hide the objects of the first level of overlapping so they wont be left as 'ghosts'
        if (offset > 0)
        {
            objName = "bsl_down_rect_"+tf+"_"+(NBSL-2-offset+1);
            ObjectSet(objName, OBJPROP_TIME1, 0);
            ObjectSet(objName, OBJPROP_TIME2, 0);
            ObjectSet(objName, OBJPROP_PRICE1, 0);
            ObjectSet(objName, OBJPROP_PRICE2, 0);

            objName = "bsl_down_bar_"+tf+"_"+(NBSL-2-offset+1);
            ObjectSet(objName, OBJPROP_TIME1, 0);
            ObjectSet(objName, OBJPROP_TIME2, 0);
            ObjectSet(objName, OBJPROP_PRICE1, 0);
            ObjectSet(objName, OBJPROP_PRICE2, 0);
        }
           
      
        double lowest=9999.9999;
        for (i=0; i<NBSL-1; i++)
        {
            objName = "bsl_down_rect_"+tf+"_"+(i-offset);
            ObjectSet(objName, OBJPROP_TIME1, curTime+shift+tf*spacing);
            ObjectSet(objName, OBJPROP_TIME2, curTime+shift+tf*spacing+width);
            ObjectSet(objName, OBJPROP_PRICE1, bsl_down[tf][i]);
            ObjectSet(objName, OBJPROP_PRICE2, bsl_down[tf][i+1]);
         
            if (bsl_down[tf][i]<lowest) lowest=bsl_down[tf][i+1];
            
            objName = "bsl_down_bar_"+tf+"_"+(i-offset);
            ObjectSet(objName, OBJPROP_TIME1, curTime+shift+tf*spacing+xUnit);
            ObjectSet(objName, OBJPROP_TIME2, curTime+shift+tf*spacing+width-xUnit);
            ObjectSet(objName, OBJPROP_PRICE1, bsl_down[tf][i]);
            ObjectSet(objName, OBJPROP_PRICE2, bsl_down[tf][i]);
        }
        
            objName = "ext_bsl_down_rect_"+tf;
            ObjectSet(objName, OBJPROP_TIME1, curTime+shift+tf*spacing);
            ObjectSet(objName, OBJPROP_TIME2, curTime+shift+tf*spacing+width);
            ObjectSet(objName, OBJPROP_PRICE1, lowest);
            ObjectSet(objName, OBJPROP_PRICE2, WindowPriceMin());
        
                        objName = "ext_down_svr_"+tf;
                ObjectSet(objName, OBJPROP_TIME1, curTime+shift+tf*spacing+2*xUnit);
                ObjectSet(objName, OBJPROP_TIME2, curTime+shift+tf*spacing+2*xUnit);
                ObjectSet(objName, OBJPROP_PRICE1, lowest);
                ObjectSet(objName, OBJPROP_PRICE2, WindowPriceMin());
       
                    ObjectSet(objName, OBJPROP_COLOR, FireBrick);

        
/*        
        // drawing the boxes
        objName = "Box1_"+tf;
        ObjectSet(objName, OBJPROP_TIME1, curTime+shift+tf*spacing+xUnit);
        ObjectSet(objName, OBJPROP_PRICE1, fml[tf][0]);
        if (fml[tf][0] > price+point/2)       col = Magenta;
        else if (fml[tf][0] < price-point/2)  col = Lime;
        else                                col = Brown;
        ObjectSet(objName, OBJPROP_COLOR, col);
        objName = "Box2_"+tf;
        ObjectSet(objName, OBJPROP_TIME1, curTime+shift+tf*spacing+xUnit);
        ObjectSet(objName, OBJPROP_PRICE1, fml[tf][1]);
        if (fml[tf][1] > price+point/2)       col = Magenta;
        else if (fml[tf][1] < price-point/2)  col = Lime;
        else                                col = Brown;
        ObjectSet(objName, OBJPROP_COLOR, col);
*/        
        // drawing the momentum lines bars
        for (i=0; i<7; i++)
        {
            objName = "fml_bar_"+tf+"_"+i;
            ObjectSet(objName, OBJPROP_TIME1, curTime+shift+tf*spacing+xUnit);
            ObjectSet(objName, OBJPROP_TIME2, curTime+shift+tf*spacing+width-xUnit);
            ObjectSet(objName, OBJPROP_PRICE1, fml[tf][i]);
            ObjectSet(objName, OBJPROP_PRICE2, fml[tf][i]);
/*
            if (i<2)
            {
                if (fml[tf][i] > price+point/2)      col = Magenta;
                else if (fml[tf][i] < price-point/2) col = Lime;
                else                                col = Brown;
                ObjectSet(objName, OBJPROP_COLOR, col);
            }
*/            
            if (i==1)
            {
                if (fml[tf][i] >= price)        col = IndianRed;
                else if (fml[tf][i] < price)    col = LimeGreen;
                ObjectSet(objName, OBJPROP_COLOR, col);
            }
            else if (i==0)
            {
                if (fml[tf][i] >= price)        col = FireBrick;
                else if (fml[tf][i] < price)    col = Green;
                ObjectSet(objName, OBJPROP_COLOR, col);
            }
        }

        // drawing the solid vertical lines:
        // arranging all the bars levels in a single sorted array

     
        ArrayInitialize(srl, -1) ;
        for (i=0; i<7; i++)
            srl[i] = fml[tf][i];
        for (i=offset; i<NBSL; i++)
        {
            srl[7+i] = bsl_down[tf][i];
            srl[7+NBSL+i] = bsl_up[tf][i];
        }
        srl[7+2*NBSL] = price;
        ArraySort(srl);
        // looking for a gap of 10 pips or more
        c = 0;
        int supports=0;
        int resistances=0;
        for (i=0; i<7+2*NBSL+2; i++)
        {
                        if(srl[i]>price) resistances++;
                if(srl[i]<price) supports++;
            if (-1 == srl[i])
                continue;
            if (srl[i+1]-srl[i] >= gap*point)
            {
                c++;
                objName = "svr_"+tf+"_"+c;
                ObjectSet(objName, OBJPROP_TIME1, curTime+shift+tf*spacing+2*xUnit);
                ObjectSet(objName, OBJPROP_TIME2, curTime+shift+tf*spacing+2*xUnit);
                ObjectSet(objName, OBJPROP_PRICE1, srl[i]+point);
                ObjectSet(objName, OBJPROP_PRICE2, srl[i+1]-point);

                if (srl[i+1] <= price)
                    {
                    if(price==srl[i+1])
                    {
                    short_gap_count++;
                    }
                    ObjectSet(objName, OBJPROP_COLOR, FireBrick);
                    }
                else
                    {
                    if(price==srl[i])
                    {
                    long_gap_count++;
                    }
                    ObjectSet(objName, OBJPROP_COLOR, Green);
                    }
            }
            if (srl[i+1]-srl[i] >= srgap*point)
            {
                if (srl[i+1] <= price)
                {
                    if(price==srl[i+1])
                    {
                      sr_short_gap_count++;
                    }
                }
                else
                {
                    if(price==srl[i])
                    {
                     sr_long_gap_count++;
                    }

               }
            }

        }
            if(supports==0) 
            {
             sr_short_gap_count++;
             short_gap_count++;
            }
            if(resistances==0) 
            {
             sr_long_gap_count++;
              long_gap_count++;
            }

        if (c >= NSVR)
            Print("Warning: NSVR exceeded");
        else
        {
            // hide the (only the first) unused vertical lines objects so they wont be left as 'ghosts'
//            for (sr=c; sr<NSVR; sr++)
            {
                objName = "svr_"+tf+"_"+(c+1);
                ObjectSet(objName, OBJPROP_TIME1, 0);
                ObjectSet(objName, OBJPROP_TIME2, 0);
                ObjectSet(objName, OBJPROP_PRICE1, 0);
                ObjectSet(objName, OBJPROP_PRICE2, 0);
            }
        }
    }
 //   Alert(Symbol()+toggle_status);
 //Comment(toggle_status);
 obj_name="what";
 ObjectDelete(obj_name);
 //ObjectCreate(obj_name,OBJ_TEXT,NULL,Time[posx-40],WindowPriceMax()-(win_height*1/100));
 
 ObjectSetText(obj_name,"Support - "+DoubleToStr(4-sr_short_gap_count,0)+" Resistance - "+DoubleToStr(4-sr_long_gap_count,0),7);
obj_name="what2";
 ObjectDelete(obj_name);
 //ObjectCreate(obj_name,OBJ_TEXT,NULL,Time[posx-40],WindowPriceMax()-(win_height*5/100));
 
 ObjectSetText(obj_name,"Short Gap - "+DoubleToStr(short_gap_count,0)+"  Long Gap - "+DoubleToStr(long_gap_count,0),7);

ObjectDelete("Trade"); 
bool is_trade=false;
bool is_short=false;
bool is_long=false;
  //  if(toggle_status==1)
    {
     obj_name="Trade";
ObjectDelete("Trade");
 //ObjectCreate(obj_name,OBJ_TEXT,NULL,Time[posx-35],WindowPriceMin()+(win_height*20/100));
bool long_it=false;
if (short_gap_count>2 &&   sr_long_gap_count<2) long_it=true;
if (short_gap_count>3 &&   sr_long_gap_count<3) long_it=true;
if(Minute()==0) prev_short_setup=prev_short_setup-60;
if(Minute()==0) prev_long_setup=prev_long_setup-60;
if(long_it)
{
if(prev_short_setup<Minute()-4 && toggle_status==1)
{// Alert(Symbol()+" Short Setup");
//Alert(long_gap_count);
prev_short_setup=Minute();

}
is_trade=true;
is_short=true;
}

bool short_it=false;
if (long_gap_count>2 && sr_short_gap_count<2) short_it=true;
if (long_gap_count>3 && sr_short_gap_count<3) short_it=true;
if(short_it)
{
if(prev_long_setup<Minute()-4 && toggle_status==1)
{
//Alert(Symbol()+" Long Setup");
//MessageBox("a","b",1);
prev_long_setup=Minute();

}
is_trade=true;
is_long=true;
}
  
  if(!is_trade)
  {
 ObjectSetText(obj_name,"No Trade",12);}
else
{
string cursbear;
string cursbull;
if (Symbol()=="GBPUSD")
{
//cursbear="GBP USD Bearish ?";
//cursbull="GBP USD Bullish ?";
}
if (Symbol()=="EURUSD")
{
//cursbear="USD Bearish ?";
//cursbull="USD Bullish ?";
}
if(is_long)
{
 ObjectSetText(obj_name,"Long ?"+cursbear ,12);
}
if(is_short)
{
ObjectSetText(obj_name,"Short ?"+cursbull,12);
}
}
}
    return(0);
}
       string the_time()
  {
  
  string t;
  t=DoubleToStr(Day(),0)+"/"+DoubleToStr(Month(),0)+" "+DoubleToStr(Hour(),0)+":"+DoubleToStr(Minute(),0)+":"+DoubleToStr(Seconds(),0)+" ";
   t=DoubleToStr(Hour(),0)+":"+DoubleToStr(Minute(),0)+":"+DoubleToStr(Seconds(),0)+" ";

  return(t);
  }
  
    void show_light(string obj_name,double average,color lcolor,int mac,string dir)
  {
mac=mac*3;
    int xUnit = Period() * 60;
     ObjectDelete(obj_name);
   ObjectCreate(obj_name,OBJ_TEXT,0,Time[WindowFirstVisibleBar()]+5*xUnit+(mac*xUnit),WindowPriceMax()-0.001);//,WindowPriceMax()-0.001,Time[0]+5*xUnit+(tfshift*xUnit),WindowPriceMax()-0.001);
   ObjectSetText(obj_name,dir,15);
   ObjectSet(obj_name,OBJPROP_COLOR, lcolor); 
    ObjectSet(obj_name,OBJPROP_RAY, false); 
     ObjectSet(obj_name,OBJPROP_WIDTH, 3); 
  
  }